/*
 * Copyright (C) 2023, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: wangyan <wangyan@kylinos.cn>
 *
 */

#ifndef CONFIGMANAGER_H
#define CONFIGMANAGER_H

#include <QString>
#include <QSettings>

struct TouchDeviceConfigInfo {
    QString deviceName;
    QString productId;
    QString serial;

    bool operator==(const TouchDeviceConfigInfo& rhs) {
        if (rhs.deviceName == deviceName && rhs.productId == productId && rhs.serial == serial)
            return true;

        return false;
    }
};

class ConfigManager
{
public:
    ConfigManager(QString filepath);
    void saveConfigInfo(QString outputName, const TouchDeviceConfigInfo& touchDevice);

private:
    int findMapId(const TouchDeviceConfigInfo& touchDevice);
    int createNewMapId();
    void updateMapCount();

    QSettings m_config;
};

#endif // CONFIGMANAGER_H
